/*
 * Example: discrete functions with strings as domain (map strings).
 * Copyright (C) 1999  Leandro Bernsmller
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */



#include <stdio.h>
#include "../../../include/base.h"



int main ()
{
	// inserting elements

	class_mapstr test;

	test.insert ("foo", 5);
	test.insert ("bar", 1);
	test.insert ("foo", 4);

	// show the number of elements in map

	printf ("number of elements: %d.\n", test.get_total_nodes ());

	// show all elements

	puts ("Elements in map:");

	for (int n = 0; n < (int) test.get_total_nodes (); n++) {

		char *key;
		DATAPT value;

		key = test.get_at_position (n, value);

		printf ("element %d: (%s, %d)\n", n, key, (int) value);
	}

	// search for one specific key

	DATAPT value;
	DWORD num = test.get_value ("foo", value);

	printf ("Was found %d elements with key '%s'. First visible has value: %d.\n",
		num, "foo", (int) value);

	// insert one element

	puts ("Inserting...");

	test.insert ("col", 7);

	// show all elements

	puts ("Elements in map:");

	for (int n = 0; n < (int) test.get_total_nodes (); n++) {

		char *key;
		DATAPT value;

		key = test.get_at_position (n, value);

		printf ("element %d: (%s, %d)\n", n, key, (int) value);
	}

	// remove all elements

	test.terminate ();

}
