/*
 * Declare plist.cc
 * See source file for details.
 */



#ifndef __LAO_PLIST_H__
#define __LAO_PLIST_H__



// The possible types of lists, each one define one way
// lists can be activated (defining one specific head behavior).
enum l_list_type {
  LAOL_UNDEFINED,    // none
  LAOL_LITERAL,
  LAOL_IMMEDIATE,
  LAOL_DIRECT,
  LAOL_INDIRECT
};



class class_plist
{
 public:

  class_plist();
  ~class_plist ();

  void  init ();
  void  terminate ();
  DATAPT process_list_end (symbol_info*);
  DATAPT process_symbol (symbol_info*);
  DATAPT return_component ( class_enviroment*, class_sbase_history* );
  DATAPT sync_recognition ( class_enviroment*, class_sbase_history* );
  DATAPT recognition_token_succ ( class_component*, class_enviroment*, class_sbase_history*);

  DATAPT get_list_type ();
  void set_list_type (DATAPT);
  DATAPT get_inner_type ();
  void set_inner_type (DATAPT);

  private:
  DWORD m_state;        // state for automatus
  l_list_type m_list_type;    // type of list
  l_list_type m_inner_type;   // type of inner list which begin was recognized
};



// call function
CALLFN (call_plist);



// end declarations
#endif
