/*
 * Declare mparser.cc
 * See source file for details.
 */



#ifndef __SBASE_MPARSER_H__
#define __SBASE_MPARSER_H__



class class_multiparser {

  public:

  class_multiparser ();
  ~class_multiparser ();

  private:

  class_mapstr m_parsers;     // All parsers (keys define a type,
                              // values define the parser in use for that type).
  DWORD m_parse_pos;          // the parser that is trying to recognize a symbol
  DWORD m_num_parsers_type;   // number of parsers for the type in use
  DWORD m_all_pos;            // parser activated, while activativing all top parsers

  public:

  void  init ();
  void  terminate (class_enviroment*, class_sbase_history*);
  BOOL add_type (char*, class_component*);
  BOOL push_parser (class_enviroment* env, class_sbase_history* hist);
  class_component* pop_parser ();
  class_component* get_parser_in_use ();
  BOOL use_first_type ();
  BOOL use_next_type ();
  DATAPT activate_type (DATAPT, class_enviroment*, class_sbase_history*, DATAPT);
  void start_activate_all ();
  DATAPT activate_all (DATAPT, class_enviroment*, class_sbase_history*, DATAPT, BOOL);
};



// end declarations
#endif
