/*
 * Declare shistory.cc and macros
 * See source file for details.
 */



#ifndef __SBASE_SHISTORY_H__
#define __SBASE_SHISTORY_H__



// common labels
#define LH_ERROR "error"
#define LH_DEBUG "debug"
#define LH_EXIT_CODE "exit-code"
#define LH_ERROR "error"
#define LH_EXCEPTION "exception"
#define LH_TEXT "text"



// exception flags
// maximal number of flags: 8 (see class_sbase_history::set_exception)
#define LE_EXIT 1
#define LE_DEBUG 2
#define LE_WARNING 4
#define LE_ERROR 8
#define LE_FATAL_ERROR 16



class class_sbase_history:public class_history {

	public:

	class_sbase_history ();
	~class_sbase_history ();

 private:
	BOOL m_fatal_error;  // flag serious error (interpreted need abort)

 public:

	// external functions
	void  init ();
	void  terminate ();
	BOOL predefine_messages ();

	l_error get_error ();
	l_debug get_debug_mode ();
	int get_exit_code ();
	BOOL has_error ();
	BOOL has_debug ();
	BOOL has_warning ();
	BOOL has_exit ();
	BOOL has_fatal_error ();
	void show (FILE*);

	BOOL add_flag ( char*, DATAPT );
	BOOL add_text ( char*, char* );
	BOOL add_predef_text ( char*, char*);
	char* get_predef_text ( char*);
	BOOL set_exception (DWORD);
};



// end declarations
#endif
