/*
 * Implement character object.
 * 
 * LICENSE:
 *
 * Copyright (C) 2000 Leandro Bernsmller
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */



#include <stdio.h>
#include <ctype.h>
#include "../../include/base/type.h"
#include "../../include/base/char.h"



class_char::class_char ()
{
	init ();
}



class_char::~class_char ()
{
	terminate ();
}



void  class_char::
init ()
{
	m_character = 0;
}



void  class_char::
terminate ()
{
	init ();
}



/*
 * Set character. 
 */
void  class_char::
set (char ch)
{
	m_character = ch;
}



/*
 * Get the character. 
 */
char  class_char::
get ()
{
	return m_character;
}





/*
 * Get a character from the given file descriptor.
 * descriptor - file descriptor
 * set member:
 * m_character - char code or 0, if EOF was read
 */
void  class_char::
import (FILE * descriptor)
{
  if (!feof (descriptor))
    m_character = getc (descriptor);
  else
    m_character = 0;
}
