/*
 * Implement the enviroment - variable and value relationship.
 * 
 * LICENSE:
 *
 * Copyright (C) 2000 Leandro Bernsmller
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */



#include "../../include/base.h"
#include "../../include/sbase/def.h"
#include "../../include/sbase/env.h"
class class_sbase_history;
#include "../../include/sbase/comp.h"



class_enviroment::class_enviroment ()
{
	init ();
}



class_enviroment::~class_enviroment ()
{
}



void  class_enviroment::
init ()
{
      class_mapstr::init ();
}



/*
 * Clear the table.
 */
void  class_enviroment::
terminate ()
{
      class_mapstr::terminate ();
}



/*
 * Search for a given key on map.
 * key - key to search for
 * param_name - name (key) used to identify the parameters list
 * param_l - the parameters list (the list is one class_component instance)
 * return:
 * value - value related with the first key found
 * total of match elements (elements with same keys)
 */
DWORD class_enviroment::
get_value (char *key, char *param_name,
	   class_component * param_l,
	   class_component ** value)
{
	// verify if key is the parameters list name
	if (strcmp (key, param_name) == 0) {
		// the key refer to parameters list, not to one map element
		*value = param_l;
		return 1;
	}


      return class_mapstr::get_value (key, put_in *value);
}



/*
 * Add one component to the enviroment.
 * return:
 * TRUE - ok / FALSE - error
 */
BOOL  class_enviroment::
insert (char *key, class_component * value)
{
      return class_mapstr::insert (key, get_from value);
}



/*
 * Removes the first component found with the given key (name).
 * return:
 * value - the value component
 * the name string or 00 if not found.
 */
char* class_enviroment::
remove (char *key, class_component** value)
{
      return class_mapstr::remove (key, put_in *value);
}



/*
 * Show all enviroment names
 */
void class_enviroment::
show_names ()
{
	DWORD pos = 0;    
	char* str = 0;
	DATAPT val = 0;
        while ( ( str = get_at_position ( pos ++, val ) ) )
		printf ( "[%s] ", str );
} 
