/*
 * Standard Lao component: declare a new component.
 * Parameters:
 * - a name to identify activation parameters
 * - a name to identify the component data
 * - one component to be used as data storage
 *   (refered by the second given name)
 * - one component to be activated as the body
 * 
 * LICENSE:
 *
 * Copyright (C) 2000 Leandro Bernsmller
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */



#include <stdio.h>
#include "../../include/lao.h"
//#include "../../include/stdcomp/declare.h"



class_stdcomp_declare::class_stdcomp_declare ()
{
	init ();
}



class_stdcomp_declare::~class_stdcomp_declare ()
{
  terminate ();
}



void  class_stdcomp_declare::
init ()
{
}



void  class_stdcomp_declare::
terminate ()
{
}



/*
 * Function to handle component messages.
 * self - class_component instance for this object
 * msg - lao system message ID
 * env - reference to lao name table
 * pdata - points component data
 * param - component parameters
 *
 * return:
 * message process result
 */
DATAPT
call_stdcomp_declare (class_component * self, DATAPT msg, class_enviroment * env, DATAPT * pdata, DATAPT param)
{
	if (pdata == 00) return 0;

	switch (msg) {

	case BIN_CREATE_DATA:
		{

			if (*pdata == 00) {

				*pdata = (DATAPT) malloc (sizeof (class_stdcomp_declare));
				if (*pdata) {

					// define information
					class_stdcomp_declare *codecl = (class_stdcomp_declare *) * pdata;
					codecl->init ();

					// REVIEW - continua: deve iniciar os dados da classe com os parametros recebidos
				}

				return *pdata;
			}
		}
		break;


	case CLEAN_DATA:
		break;

	case INVOKE:
	case INVOKE_AS_REFERENCE:
	  return self->call (ACTIVATE, env, param);
	  break;

	case ACTIVATE:
	case ACTIVATE_AS_REFERENCE:
		{
		}
		break;

	case ACTIVATE_AS_PARAMETER:
		return (DATAPT) self;
		break;

	case BINARY_ACTIVATE:
		break;

	case BIN_GET_TEXT_REPRESENTATION:
		{
			class_string *str = (class_string *) malloc (sizeof (class_string));
			str->init ();
			str->append ("_declare_");
			return (DATAPT) str;
		}
		break;

        case COPY:
                {
                   return (DATAPT) build_component ((DATAPT) 0, ::call_stdcomp_declare, "<declare>", "<declare>");
		}
		break;
	}

	return (DATAPT) self;
}
